/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package flac2mp3;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author micha
 */
public class LAF extends JFrame implements ActionListener {

    JFileChooser fileChooserFlac;
    JFileChooser fileChooserDir;
    File[] flacFiles;
    File zielVerzeichnis;
    JTextArea jTextAreaLinks;
    JTextArea jTextAreaRechts;

    public void actionPerformed(ActionEvent event) {
        String kommando = event.getActionCommand();

        if (kommando.equals("flacWaehlen")) {

            //file auswaehlen
            fileChooserFlac.setFileSelectionMode(JFileChooser.FILES_ONLY);
            fileChooserFlac.setDialogTitle("flac-dateien auswählen");
            fileChooserFlac.setApproveButtonText("file oeffnen");
            fileChooserFlac.setMultiSelectionEnabled(true);

            int returnVal = fileChooserFlac.showOpenDialog(this);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                flacFiles = fileChooserFlac.getSelectedFiles();
                for (int i = 0; i < flacFiles.length; i++) {
                    System.out.printf("ausgewählt worden sind: %s\n", flacFiles[i].getName());
                    this.jTextAreaLinks.append(flacFiles[i].getName() + "\n");
                }
            }
        } else if (kommando.equals("konvertieren")) {
            //verzeichnis auswaehlen
            fileChooserDir.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            fileChooserDir.setDialogTitle("mp3 sichern in");
            fileChooserDir.setApproveButtonText("mp3 sichern");
            fileChooserDir.setAcceptAllFileFilterUsed(false);
            int returnVal = fileChooserDir.showOpenDialog(this);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                this.zielVerzeichnis = fileChooserDir.getSelectedFile();
                System.out.println(zielVerzeichnis);
                this.konvert();
            }

        } else if (kommando.equals("beenden")) {
            System.out.println("menuItem 'Beenden'");
            dispose();
            System.exit(0);
        }
        //************datSchliessen*******************************************
    }

    public LAF() {
        super("Ein flac-nach-mp3-Konverter");

        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setSize(600, 400);
        Container container = this.getContentPane();
        container.setLayout(new BorderLayout());

        jTextAreaLinks = new JTextArea();
        jTextAreaLinks.setLineWrap(true);
        jTextAreaLinks.setMinimumSize(new Dimension(100, 50));
        //jTextAreaLinks.setTabSize( 3 );
        //jSplitPane.setLeftComponent( jTextAreaLinks );

        jTextAreaRechts = new JTextArea();
        jTextAreaRechts.setLineWrap(true);
        jTextAreaRechts.setMinimumSize(new Dimension(100, 50));
        //jTextArea.setTabSize( 3 );
        //jSplitPane.setRightComponent( jTextAreaRechts );

        Box boxLinks = new Box(BoxLayout.Y_AXIS);
        //boxLinks.setLayout( new GridLayout( 2, 1 ) );
        //boxLinks.setMinimumSize( new Dimension( 30, 60 ) );

        Box boxRechts = new Box(BoxLayout.Y_AXIS);
        //boxRechts.setLayout( new GridLayout( 2, 1 ) );
        //boxRechts.setMinimumSize( new Dimension( 30, 60 ) );

        JLabel quelle = new JLabel("---- Quelle ----");
        JLabel ziel = new JLabel("---- Ziel -----");

        boxLinks.add(quelle);
        boxLinks.add(jTextAreaLinks);

        boxRechts.add(ziel);
        boxRechts.add(jTextAreaRechts);

        //erzeugen einer JSSplitPane fuer oirginale und rsa-codierte daten
        JSplitPane jSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, boxLinks, boxRechts);
        //jSplitPane.setDividerLocation( 1.0 );
        jSplitPane.setResizeWeight(0.5);
        container.add(jSplitPane, BorderLayout.CENTER);

        //erzeugen eines filter-objekts einer namenlosen, inneren
        //klasse, die von FileFilter erbt. filter wird fuer dateiauswahldialoge
        //benoetigt
        FileFilter filterFlac =
                new FileFilter() {

                    public boolean accept(File f) {
                        if (f.isDirectory() | f.getName().endsWith(".flac")) {
                            return true;
                        } else {
                            return false;
                        }
                    }

                    public String getDescription() {
                        return ".flac";
                    }
                };

        FileFilter filterDir =
                new FileFilter() {

                    public boolean accept(File f) {
                        if (f.isDirectory()) {
                            return true;
                        } else {
                            return false;
                        }
                    }

                    public String getDescription() {
                        return "zielverzeichnis";
                    }
                };

        //erzeugen der datei-auswahl-dialog-objekte und
        //setzen deren datei-filter
        fileChooserFlac = new JFileChooser("/home/micha/mp3test");
        fileChooserFlac.setFileFilter(filterFlac);
        fileChooserFlac.addChoosableFileFilter(filterFlac);

        fileChooserDir = new JFileChooser("/home/micha/mp3test");
        fileChooserDir.setFileFilter(filterDir);
        fileChooserDir.addChoosableFileFilter(filterDir);


        //meueleiste erzeugen

        JMenuBar menueLeiste = new JMenuBar();

        JMenu ablageMenue = new JMenu("Ablage");

        JMenuItem oeffnen = new JMenuItem("flac-Dateien");
        oeffnen.setAccelerator(KeyStroke.getKeyStroke("shift control O"));
        ablageMenue.add(oeffnen);
        oeffnen.addActionListener(this);
        oeffnen.setActionCommand("flacWaehlen");

        JMenuItem sichern = new JMenuItem("flac -> mp3");
        sichern.setAccelerator(KeyStroke.getKeyStroke("control S"));
        ablageMenue.add(sichern);
        sichern.addActionListener(this);
        sichern.setActionCommand("konvertieren");

        JMenuItem beenden = new JMenuItem("beenden");
        beenden.setAccelerator(KeyStroke.getKeyStroke("control Q"));
        ablageMenue.add(beenden);
        beenden.addActionListener(this);

        menueLeiste.add(ablageMenue);

        /*
        JMenu bearbeitenMenue = new JMenu("Bearbeiten");
        
        JMenuItem widerrufen = new JMenuItem("Widerrufen");
        widerrufen.setAccelerator(KeyStroke.getKeyStroke("control Z"));
        bearbeitenMenue.add(widerrufen);
        widerrufen.addActionListener(this);
        
        JMenuItem wiederholen = new JMenuItem("Wiederholen");
        wiederholen.setAccelerator(KeyStroke.getKeyStroke("shift control Z"));
        bearbeitenMenue.add(wiederholen);
        wiederholen.addActionListener(this);
        
        JMenuItem ausschneiden = new JMenuItem("Ausschneiden");
        ausschneiden.setAccelerator(KeyStroke.getKeyStroke("control X"));
        bearbeitenMenue.add(ausschneiden);
        ausschneiden.addActionListener(this);
        
        JMenuItem kopieren = new JMenuItem("Kopieren");
        kopieren.setAccelerator(KeyStroke.getKeyStroke("control C"));
        bearbeitenMenue.add(kopieren);
        kopieren.addActionListener(this);
        
        JMenuItem einsetzen = new JMenuItem("Einsetzen");
        einsetzen.setAccelerator(KeyStroke.getKeyStroke("control V"));
        bearbeitenMenue.add(einsetzen);
        einsetzen.addActionListener(this);
        
        JMenuItem loeschen = new JMenuItem("Loeschen");
        loeschen.setAccelerator(KeyStroke.getKeyStroke("meta D"));
        bearbeitenMenue.add(loeschen);
        loeschen.addActionListener(this);
        loeschen.setActionCommand("loeschen");
        
        JMenuItem allesAuswaehlen = new JMenuItem("Alles auswaehlen");
        allesAuswaehlen.setAccelerator(KeyStroke.getKeyStroke("control A"));
        bearbeitenMenue.add(allesAuswaehlen);
        allesAuswaehlen.addActionListener(this);
        
        
        menueLeiste.add(bearbeitenMenue);
         */



        this.setJMenuBar(menueLeiste);

        setVisible(true);
    }

    private void konvert() {
        String[] cmd = new String[5];
        String mp3Name;
        String flacName;
        jTextAreaRechts.append(" Es wurden konvertiert: \n");

        try {
            Runtime rt = Runtime.getRuntime();
            Process p;
            BufferedReader in;

            cmd[0] = "/usr/bin/sox";
            cmd[1] = "-V4";
            cmd[3] = "-C 128.2";

            for (int i = 0; i < flacFiles.length; i++) {
                flacName = flacFiles[i].getAbsolutePath();
                mp3Name = zielVerzeichnis + "/" + flacFiles[i].getName().replace("flac", "mp3");
                cmd[2] = flacName;
                cmd[4] = mp3Name;
                p = rt.exec(cmd);
                in = new BufferedReader(new InputStreamReader(p.getErrorStream()));
                p.waitFor(); // warte solange bis der process beendet ist dann bringe die meldung ;)
                
                System.out.println("sox meldet: ");
                while(in.ready()){
                    System.out.println(in.readLine());
                }
                    jTextAreaRechts.append(cmd[4] + "\n");
            }
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new LAF();
    }
}
